=== src/helpers/CMakeLists.txt ===
add_subdirectory(killer)
