=== src/backends/x11/CMakeLists.txt ===
if (KWIN_BUILD_X11_BACKEND)
    add_subdirectory(standalone)
endif()
