=== src/plugins/fadedesktop/CMakeLists.txt ===
kwin_add_scripted_effect(fadedesktop package)
