=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-kf6,
-               breeze-dev (>= 4:6.5.2~),
+               breeze-dev (>= 4:6.5.3~),
                cmake (>= 3.16~),
                extra-cmake-modules (>= 6.18.0~),
                gettext,
-               knighttime-dev (>= 6.5.2~),
+               knighttime-dev (>= 6.5.3~),
                kscreenlocker-dev (>= 6.4.91~),
-               kwayland-dev (>= 4:6.5.2~),
+               kwayland-dev (>= 4:6.5.3~),
                libcanberra-dev,
                libcap-dev [linux-any],
                libcap2-bin [linux-any],
@@ -23,7 +23,7 @@
                libfontconfig-dev,
                libfreetype-dev,
                libgbm-dev,
-               libkdecorations3-dev (>= 4:6.5.2~),
+               libkdecorations3-dev (>= 4:6.5.3~),
                libkf6auth-dev (>= 6.18.0~),
                libkf6colorscheme-dev (>= 6.18.0~),
                libkf6config-dev (>= 6.18.0~),
@@ -50,8 +50,8 @@
                libkglobalacceld-dev (>= 6.4.91~),
                libkirigami-dev (>= 6.18.0~),
                liblcms2-dev,
-               libplasma-dev (>= 6.5.2~),
-               libplasmaactivities-dev (>= 6.5.2~),
+               libplasma-dev (>= 6.5.3~),
+               libplasmaactivities-dev (>= 6.5.3~),
                libqaccessibilityclient-qt6-dev,
                libsystemd-dev [linux-any],
                libudev-dev [linux-any],
