## kwin-x11 6.5.3+p24.04+vunstable+git20251201.0016

=== debian/changelog ===
kwin-x11 (4:6.5.3+p24.04+vunstable+git20251201.0016-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 01 Dec 2025 00:16:07 +0000

kwin-x11 (4:6.5.3-0neon) Noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 09:11:54 +1000

kwin-x11 (4:6.5.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 06 Nov 2025 19:11:27 +1000
