## kwin-x11 6.5.3+p24.04+vunstable+git20251202.1135

=== debian/changelog ===
kwin-x11 (4:6.5.3+p24.04+vunstable+git20251202.1135-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 02 Dec 2025 11:35:27 +0000
