=== debian/changelog ===
kwin-x11 (4:6.5.3+p24.04+vunstable+git20251209.0402-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 09 Dec 2025 04:02:45 +0000
